# encoding: utf-8

module Settings
  #
  #
  #
  class ENV
    #
    #
    #
    def self.load(hsh)
      new(hsh)
    end

    #
    #
    #
    attr_reader :data

    private

    def initialize(hsh)
      msg = "object #{hsh} should be an instance of Hash!"
      raise HashNotValid, msg unless Hash === hsh
      @data = hsh.dup
    end

    #
    # This is supposed to be raised when self.load got a wrong object which
    # can't response as a Hash.
    #
    class HashNotValid < StandardError; end
  end # class Settings::YAML
end # module Settings
